VERSION 5.00
Object = "{95299E18-49EF-11D3-AE2E-00608CC1DD62}#1.0#0"; "S309HotKey.ocx"
Begin VB.Form Form1 
   Caption         =   "S309HotKey Example"
   ClientHeight    =   4164
   ClientLeft      =   60
   ClientTop       =   348
   ClientWidth     =   3612
   LinkTopic       =   "Form1"
   ScaleHeight     =   4164
   ScaleWidth      =   3612
   Begin VB.CommandButton btnUnAll 
      Caption         =   "Unregister All"
      Height          =   372
      Left            =   2400
      TabIndex        =   9
      Top             =   0
      Width           =   1212
   End
   Begin VB.Frame fraSoftKey 
      Caption         =   "HotKey"
      Height          =   1092
      Left            =   0
      TabIndex        =   2
      Top             =   360
      Width           =   3612
      Begin VB.CommandButton btnRegister 
         Caption         =   "Register Key"
         Height          =   252
         Left            =   120
         TabIndex        =   8
         Top             =   720
         Width           =   1332
      End
      Begin VB.CheckBox chkShift 
         Caption         =   "Shift Key Needed"
         Height          =   252
         Left            =   1800
         TabIndex        =   7
         Top             =   720
         Width           =   1572
      End
      Begin VB.CheckBox chkControl 
         Caption         =   "Control Key Needed"
         Height          =   252
         Left            =   1800
         TabIndex        =   6
         Top             =   480
         Width           =   1692
      End
      Begin VB.CheckBox chkAlt 
         Caption         =   "Alt Key Needed"
         Height          =   252
         Left            =   1800
         TabIndex        =   5
         Top             =   240
         Width           =   1572
      End
      Begin VB.TextBox txtKey 
         Height          =   288
         Left            =   1440
         MaxLength       =   1
         TabIndex        =   4
         Top             =   360
         Width           =   252
      End
      Begin VB.Label Label1 
         Caption         =   "Key To Register:"
         Height          =   252
         Left            =   120
         TabIndex        =   3
         Top             =   360
         Width           =   1212
      End
   End
   Begin VB.CommandButton btnHardware 
      Caption         =   "Register Hardware HotKeys"
      Height          =   372
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   2292
   End
   Begin VB.ListBox lstMessages 
      Height          =   2160
      Left            =   0
      TabIndex        =   0
      Top             =   1680
      Width           =   3612
   End
   Begin S309HOTKEYLib.S309HotKey S309HotKey1 
      Left            =   0
      Top             =   -360
      _Version        =   65536
      _ExtentX        =   656
      _ExtentY        =   1291
      _StockProps     =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim bFirstTime As Boolean

Private Sub btnHardware_Click()
    Dim nKey As Integer
    Dim nCount As Integer
    
    nCount = 0
    
    For nKey = 193 To 207 ' hardware keycodes 0xc1 - 0xcf
        If S309HotKey1.Register(nKey, False, False, False, True) Then ' hardware keys need the Windows key modifier
            nCount = nCount + 1
        End If
    Next
    PutMessage CStr(nCount) & " Hardware keys registered."
End Sub

Private Sub btnRegister_Click()
    Dim bAlt As Boolean
    Dim bControl As Boolean
    Dim bShift As Boolean
    Dim nKey As Integer
    
    If Not bFirstTime Then
        MsgBox "Hotkeys will not work if this machine does not have a real hardware keyboard", vbInformation
        bFirstTime = True
    End If
    
    bAlt = (chkAlt.Value = 1)
    bControl = (chkControl.Value = 1)
    bShift = (chkShift.Value = 1)
    
    nKey = Asc(txtKey.Text)
    
    If S309HotKey1.Register(nKey, bAlt, bControl, bShift, False) Then
        PutMessage ReturnKey(nKey, bAlt, bControl, bShift, False) & " registered."
    Else
        PutMessage ReturnKey(nKey, bAlt, bControl, bShift, False) & " not registered."
    End If
End Sub

Private Sub btnUnAll_Click()
    If S309HotKey1.UnregisterAll() Then
        PutMessage "all hotkeys unregistered."
    Else
        PutMessage "Error unregistering all hotkeys."
    End If
End Sub

Private Sub S309HotKey1_HotKeyDown(ByVal nKey As Integer, ByVal bAlt As Boolean, ByVal bControl As Boolean, ByVal bShift As Boolean, ByVal bWindows As Boolean)
    PutMessage "KeyDown " & ReturnKey(nKey, bAlt, bControl, bShift, bWindows) & "."
End Sub

Private Sub S309HotKey1_HotKeyUp(ByVal nKey As Integer, ByVal bAlt As Boolean, ByVal bControl As Boolean, ByVal bShift As Boolean, ByVal bWindows As Boolean)
    PutMessage "KeyUp " & ReturnKey(nKey, bAlt, bControl, bShift, bWindows) & "."
End Sub

Private Function ReturnKey(ByVal nKey As Integer, ByVal bAlt As Boolean, ByVal bControl As Boolean, ByVal bShift As Boolean, ByVal bWindows As Boolean) As String
    Dim strTemp As String
    
    If (nKey >= 193) And (nKey <= 207) Then
        strTemp = "Hardware Key " & CStr(nKey - 192)
    Else
        strTemp = ""
        If bAlt Then
            strTemp = "Alt-"
        End If
        If bControl Then
            strTemp = strTemp & "Control-"
        End If
        If bShift Then
            strTemp = strTemp & "Shift-"
        End If
        If bWindows Then
            strTemp = strTemp & "Windows-"
        End If
        strTemp = strTemp & Chr(nKey)
    End If
    ReturnKey = strTemp
End Function

Private Sub PutMessage(ByVal strText As String)
    lstMessages.AddItem strText & " " & CStr(Now), 0
End Sub
